: #!/bin/sh
<<.

You must explicitly run "sh install.sh" to install MOOSE.

Do NOT use the install.conf file from the distribution if any.
DO write your own install.conf file.

If you use a floppy, put the right floppy into the drive before running
install.sh

.
#--------------------------- END OF COMMENTS ---------------------------------

#------------------------------ FUNCTIONS ------------------------------------

make_params () # make the parameter file (stdout) from the arguments
{
  # $1 is the destination's ROOT DEVICE
  # $2 is the LOAD mode
  # ...
  echo $2 | set_params $1 36
}

set_params ()
{
  # $1 is the destination file to modify.
  # $2 is the offset of the modification.
  # stdin is the parameters to copy.

  dd of=$1 conv=notrunc bs=1 seek=$2
}

#-----------------------------------------------------------------------------

RCFILE=install.conf

if [ -f ${RCFILE} ] ; then
  source ${RCFILE}
else
  echo 'You need to write your ${RCFILE:-install.conf} file prior to install.'
  exit 1
fi

cd $ARCH

case "$LOAD_MODE" in
  C)	case "$DEST" in
	  /dev/*fd*)
		(cat $BOOTSECT $LOADER $API $KERNEL ;
		 /bin/echo '\360\377')> $DEST
		make_params $DEST $LOADMODE
		;;
	  *) echo "Destination Not supported yet"
		;;
	esac
	;;
  D)	echo "Load mode Not supported yet"
	;;
  H)	echo "Load mode Not supported yet"
	;;
esac
