#!/bin/sh

function kwa () {
  awk "$@" '
  BEGIN { FS=":" ; SEP="," ; COUNT=0 }
  { if ( COUNT == NTOK ) SEP="" }
  ! /^[\ \	]*(#|$)/ {
     if (NF>1) {
        COUNT++ ;
        if ( GOAL == "HEADER" )   print $1 SEP ;
        if ( GOAL == "C"      )   {  A=$2 ;
                                     for (i=3;i<=NF;i++) A=A":"$i ;
                                     print "{"A" }"SEP
                                  }
     }
  }
  END { if ( GOAL == "COUNT"  )   print COUNT }
  '
}

function tokenize_one () {
  metafile=${filename}.mc
  hfile=${filename}.h
  cfile=${filename}.c
  ntoken=$[$(kwa -v GOAL=COUNT -v NTOK=-1 <$metafile)]
  kwa -v GOAL=HEADER -v NTOK=$ntoken <$metafile >$hfile
  kwa -v GOAL=C      -v NTOK=$ntoken <$metafile >$cfile
}

function do_tokenize () {
  for filename in "$@"
  do tokenize_one $filename
  done
}

function main () {
  if [ -z "$*" ]
  then do_tokenize Exceptn Objects
  else do_tokenize "$@"
  fi
}

main "$@"
