.xlist
if 0 ; (preliminary notes)

------------------------------------------------------------------------------
;									     ;
;			       OSLm i386 Kernel				     ;
;									     ;
------------------------------------------------------------------------------

Done:		Nothing.
Being done:	Everything.
To Do:		Everything.

------------------------------------------------------------------------------

Specifications:
A) Goals:
B) Constraints:
  Can be loaded anywhere. Only page boundary is assumed.

------------------------------------------------------------------------------

Loading Procedure:
  To load the Kernel, you must first have the API active and initialized
in memory, then, load the header somewhere in memory (see KHeader segment
group), take it into account, load the actual kernel (see OSLmKernel segment
group), initialize kernel global data (See GlobKData segment) and jump into
the kernel entry point (see KInitCode segment).

------------------------------------------------------------------------------

KHeader segment group:
* HeaderBinary segment:
   It contains data about exports of kernel code.
   It begins by a 32 byte signature identifying the kernel and its version.
   After that, it contains data about sizes of the kernel file components.
   Then, it contains .

* HeaderStrings segment:
   It contains the ascii names of objects exported by the kernel.

------------------------------------------------------------------------------

OSLmKernel segment group:
* KernelCode segment:
* GlobKData segment:
* KInitCode segment:

------------------------------------------------------------------------------


------------------------------------------------------------------------------

endif

;-----------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;; COMPILATION DIRECTIVES ;;;;;;;;;;;;;;;;;;;;;;;;;;;

IDEAL	; TASM Ideal mode (masm=#$*!@%, as any microsoft product)
;;; Listinf directives
%noctls
%noincl
%noconds
;;%nocref
masm
.xall
ideal
;%syms
;%notrunc
%list	; let's go

P386	; of course ! (allow protected mode)

;-----------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;; Macros and Headers Include ;;;;;;;;;;;;;;;;;;;;;;;;

Include "../Macro.INC"	; Macros


;-----------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;; Define segments groups ;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Masm	;; Ensure that segments will be ordered in their appearing order
.SEQ	;
Ideal	;

Group	KHeader		HeaderBinary, HeaderStrings
Group   OSLmKernel	KernelCode, GlobKData, KInitCode
Assume	cs:OSLmKernel,ds:OSLmKernel,es:OSLmKernel,ss:OSLmKernel
Assume  fs:OSLmKernel,gs:OSLmKernel

;-----------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Define segments ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Segment HeaderBinary	para public use32 'Kernel'
;
;------------------------- Signature --------------------------
;
; The first 32 bytes are reserved for the signature
; The first 20 bytes may be searched for to find the Kernel.
; The 12 remaining bytes may be used for version identification.
;
  Org 0
   MagicNumber		dd	01824B26FH
	; big-endian 	386	i	L	S	O
        ;       00  0110000010	01001	01100	10011	01111
				; 5 bit code for 'OSL' big-endian,
				; 5 bit code for i, 10-bit code for 386
				; two clear bits.
   Signature		db	"OSLm Kernel i386 v0.00.01",0
EndS

Segment HeaderStrings	byte  public use32 'Kernel'
EndS



Segment KernelCode	para  public use32 'Kernel'
EndS
Segment GlobKData	dword public use32 'Kernel'
EndS
Segment KInitCode	byte  public use32 'Kernel'
EndS


;-----------------------------------------------------------------------------
%Incl

Include "GKData.asm"	; Global Kernel Data
Include "KCode.asm"	; Kernel code
Include "KInit.asm"	; Kernel initialization
Include "KHeader.asm"	; Read header last, for it uses values of pointers in
			; the remaining of the code. But the header will
			; hopefully be first in the binary :-)

;-----------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Public data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Public definitions should allow (with a public map file)
; external programs to get the entry points rights.
;
public	KInitJumpPoint, TotalKernelFileLength
public	BeginningOfGKData, KernelOffset

;-----------------------------------------------------------------------------
End
