#ifndef MINISL_H /* Mini Stack Language */
#define MINISL_H

#include "thread/types.h"
#include "arch.h"
#include "llobjects.h"

/********************************* TYPEDEFS *********************************/
typedef struct msl_instr_tbl_t {
  void (*code) (void) ;
  char * C_name ;
  char * FORTH_name ;
} msl_instr_tbl_t ;

typedef void	      (*msl_instr_t) (void) ;	/* threaded token code */
typedef	pcore_cell	msl_cell_t ;		/* long int */


/* used for external code -> threaded code translation */


/************************** LIST OF INSTRUCTIONS ****************************/

enum minisl_intructions {
#include "minisl.ho1"
  NUM_OF_MSL_INSTR
};

/**************************** EXTERNS ****************************************/
extern msl_instr_t *	msl_pc ;
extern msl_cell_t *	msl_sp ;


/************************ Defining functions *********************************/

pcore_cell minisl (msl_instr_t* _pc,
		   pcore_cell * _sp,pcore_cell * _spbot,pcore_cell * _sptop,
		   pcore_cell * _rp,pcore_cell * _rpbot,pcore_cell * _rptop) ;
void __CodeDump__ (FILE * file,msl_instr_t * dpc) ;


#include "minisl.ho2"

#endif	/* minisl.h */
