#!./build.sh meta_c

# This is a shell script using "./build.sh meta_c" to produce
# a .co "C" program file part,
# and a .ho "C" header file part.
# awk was too bad, 'cause it couldn't understand multi-line programs


TMPFILE HO1 HO2



INSTR () {
  echo "msl_$1,		/* $3 */" > $HO1

  echo "msl_$1,		/* $3 */" > $HO2
}

LITTERAL




########################### HERE, THE CODE ##################################
BEGIN_META_C

COMMENT '
  Herein, TOP refers to the stop of the stack, NEXT to what is next to it.
  Stack is checked at each instruction. A further version will provide
  safe and unsafe versions for each instruction...
'


INSTR	VOID	"NOP"	"Does nothing" '
{
}'

INSTR	TRAP	"TRAP"	"Traps to the core system" '
{
 /* VERY dangerous !: #define TRAP_Handler(trap) (*(void (*)())trap)
 */
  TRAP_Handler(pop()) () ;
}'


INSTR	IMM	"VAL"	"Pushes an immediate value onto the stack" '
{
  check_pc(++pc) ;
  check_sp(--sp) ;
  *sp = *pc ;
}'


INSTR	ADD	"+"	"pops TOP and NEXT, push the sum." '
{
   check_sp (sp+2) ;
   *++sp += *sp ;	/* Isn't that pretty ? */
}'

INSTR	SUB	"-"	"pops TOP and NEXT, push old NEXT-TOP"
{
   push(pop()+pop()) ;
}'


END_META_C


cat > /dev/null <<'.'

PC!	JMP
PC@
BRZ	IF DROP ELSE PC! THEN
 BRNZ   IF PC! ELSE DROP THEN
 CALL   PC@ >R PC!
 RET	R> PC!


STO	!
LOD	@

NOT
AND
XOR
OR

EQ	=
LT	<
GT	>
LE	<=
GE	>=

ADD
SUB
SHR

MUL
DIVMOD

 DUP
DROP
 OVER
 SWAP

POP
PUSH

Hi-level calls:
CONTEXT		(the thread's context) (or LD ops ?)
EVAL		(object, method)
.
IN
OUT
*/

/* La machine de P. Cousot:
Void
Stop
Add
Sub
Mult
Div
Ifless	<
Ifeq   	=
BrZero
PC@
PC!
SP@
SP!
LD@
LD!
@
!
Val #n
IMM
CODE	next:=code pointed at by top

DumpCode	jusqu' fin
DumpPile	du dbut  SP (pile croissante)
Fin

.